const API = require("../../../lib/API.js");
const db = require("../../../plugin/DataBase/db.js");
const { BaseStdResponse } = require("../../../BaseStdResponse.js");
const AccessControl = require("../../../lib/AccessControl.js");

class AddAccount extends API {
    constructor() {
        super();

        this.setPath('/Lepao/Account')
        this.setMethod('POST')

        this.emailRegex = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/
        this.banEmailList = ['icloud.com']
    }

    // 生成 6 位数字 + 字母混合码
    async generateCode() {
        try {
            const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
            let code = ""
            for (let i = 0; i < 6; i++) {
                code += chars.charAt(Math.floor(Math.random() * chars.length))
            }

            let sql = 'SELECT id FROM lepao_face WHERE face_code = ?'
            let rows = await db.query(sql, [code])
            if (!rows)
                throw new Error('数据库错误，请稍后再试')
            if (rows.length > 0)
                return await this.generateCode()
            return code
        } catch (error) {
            throw error
        }
    }

    async onRequest(req, res) {
        let { uuid, session, student_num, email, id, area, auto_time, auto_run, target_count, notes } = req.body

        if ([uuid, session, student_num, email, auto_time, target_count].some(value => value === '' || value === null || value === undefined))
            return res.json({
                ...BaseStdResponse.MISSING_PARAMETER
            })

        if (isNaN(target_count) || target_count < 0 || target_count > 99) {
            return res.json({
                ...BaseStdResponse.ERR,
                msg: '乐跑目标次数不在合法范围内'
            })
        }

        if (!this.emailRegex.test(email)) {
            Message.error('请检查邮箱格式是否正确')
            return res.json({
                ...BaseStdResponse.ERR,
                msg: '请检查邮箱格式是否正确'
            })
        }

        const emailDomain = email.split('@')[1].toLowerCase()
        if (this.banEmailList.includes(emailDomain))
            return res.json({
                ...BaseStdResponse.ERR,
                msg: `暂不支持使用 ${emailDomain} 域名的邮箱，请更换其他邮箱后重试`
            })

        if (!await AccessControl.checkSession(uuid, session))
            return res.status(401).json({
                ...BaseStdResponse.ACCESS_DENIED
            })

        let countSql = 'SELECT id, create_user, total_num FROM lepao_account WHERE student_num = ?'
        let countRows = await db.query(countSql, [student_num])

        if (!countRows)
            return res.json({ ...BaseStdResponse.ERR, msg: '添加乐跑账号失败！数据库错误' })

        // 判断是否重复注册
        if (!id) {
            if (countRows.length !== 0 && countRows[0].create_user != null) {
                if (countRows[0].create_user !== uuid)
                    return res.json({ ...BaseStdResponse.ERR, msg: '该乐跑账号已被其他用户绑定，请联系客服解绑' })
                return res.json({ ...BaseStdResponse.ERR, msg: '该乐跑账号已添加' })
            }
        }

        if (countRows.length !== 0) {
            if (countRows[0].total_num >= target_count && target_count !== 0)
                return res.json({ ...BaseStdResponse.ERR, msg: '该账号累计跑步次数已达到目标次数，请尝试修改目标次数' })
        }

        const time = new Date().getTime()

        let sql, r

        if (!id) {
            if (countRows.length !== 0) {
                sql = 'UPDATE lepao_account SET create_user = ?, email = ?, area = ?, auto_time = ?, auto_run = ?, target_count = ?, create_time = ?, notes = ? WHERE id = ?'
                r = await db.query(sql, [uuid, email, area, auto_time, auto_run, target_count, time, notes ?? '', countRows[0].id])
            }
            else {
                const face_code = await this.generateCode()

                sql = 'INSERT INTO lepao_account (student_num, email, area, auto_time, auto_run, target_count, create_user, create_time, notes) VALUES (?, ?, ?, ?, ?, ?, ?, ?)'
                r = await db.query(sql, [student_num, email, area, auto_time, auto_run, target_count, uuid, time, notes ?? ''])

                let faceSql = 'INSERT INTO lepao_face (student_num, face_code) VALUES (?, ?)'
                let faceRows = await db.query(faceSql, [student_num, face_code])
                if (!faceRows || faceRows.affectedRows !== 1)
                    return res.json({ ...BaseStdResponse.ERR, msg: '添加乐跑账号失败！数据库错误' })
            }
        } else {
            sql = 'UPDATE lepao_account SET student_num = ?, email = ?, area = ?, auto_time = ?, target_count = ?, auto_run = ?, notes = ? WHERE id = ?'
            r = await db.query(sql, [student_num, email, area, auto_time, target_count, auto_run, notes ?? '', id])
        }

        try {
            if (r && r.affectedRows > 0) {
                res.json({
                    ...BaseStdResponse.OK,
                    id: r.insertId
                })
            } else {
                return res.json({ ...BaseStdResponse.ERR, msg: '添加乐跑账号失败！数据库错误' })
            }
        } catch (err) {
            this.logger.error(`添加乐跑账号失败！${err.stack}`)
            res.json({
                ...BaseStdResponse.ERR,
                msg: "添加乐跑账号失败！",
            });
        }
    }
}

module.exports.AddAccount = AddAccount;